# Coding Style

All code generated by the SNAC project will be written in one of the following languages.

* PHP 7 (preferred)
* PHP 5
* Java
* XSLT


## Coding Style Specifications

Source code must match the following style guidelines:

* 4-space tabs with literal spaces
* Maximum line-length of 100 characters
* Variables and Class names follow standard camel casing syntax, with descriptive names
    * Class names start with upper-case letters
    * Variable and field names start with lower-clase letters
    * No underscores allowed in variable names

## Internal Documentation of Code

All code will be internally-documented using [Javadoc](http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html) style documentation, which has been ported to PHP as [phpdoc](http://www.phpdoc.org/docs/latest/guides/docblocks.html).  Tools to generate documentation from the code is also available for [Java](http://www.oracle.com/technetwork/java/javase/documentation/index-jsp-135444.html) and [PHP](http://www.phpdoc.org/).

* All files, regardless of language,  must have javadoc-style documentation with author attribution, definition of the file, and short-text of the code license, as defined below:
    
    This is a test

* All classes, fields, methods, and function definitions must include documentation, as defined below:

    This is another test


